let { FileCopy } = new function(fs, path){

this.FileCopy = function(url, colors, makeDirs){
	return class FileCopy {
		constructor(paths){
			for(let from in paths){
				let result, to = paths[from], fromPath = path.parse(from);

				if(/^\*(?=$|\?)/.test(fromPath.base)){
					let ps = {}, { dir, base } = fromPath, search = url.parse(base).search || "", exts = search.length > 0 ? new url.URLSearchParams(search) : null;

					fs.readdirSync(dir).forEach((p) => {
						let pathname = `${dir}/${p}`, t = `${to}/${p}`;

						if(fs.statSync(pathname).isDirectory()){
							ps[`${pathname}/*${search}`] = t;
							return;
						}

						if(!exts || exts.has(path.parse(pathname).ext)){
							ps[pathname] = t;
						}
					});

					new FileCopy(ps);
					continue;
				}

				let filename, toPath = path.parse(to);

				result = toPath.ext ? to : `${to}/${fromPath.base + (fromPath.ext ? "" : ".js")}`;

				try {
					filename = require.resolve(from);
				}
				catch(e){
					console.log(
						colors.bgBlue("找不到指定文件：") + colors.red(from)
					);
					return;
				}

				try {
					makeDirs(result, makeDirs);

					fs.writeFileSync(
						result,
						fs.readFileSync(filename)
					);
				}
				catch(e){
					console.log(
						colors.bgBlue("写入文件失败：") + colors.red(e)
					);
					return;
				}

				console.log(
					colors.green("文件已复制：") + colors.yellow(result)
				);
			}
		};
	};
}(
	require("url"),
	require("colors/safe"),
	// makeDirs
	(dirname, callee) => {
		let p = path.parse(dirname), dir = p.ext ? p.dir : dirname;

		try {
			if(fs.statSync(dir).isDirectory()){
				return;
			}
		}
		catch(e){
			callee(
				path.resolve(dir, "../"),
				callee
			);
		}

		fs.mkdirSync(dir);
	}
);

}(
	require("fs"),
	require("path")
);

module.exports = FileCopy;